package cn.com.infosec.asn1.misc;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERSequence;

public class IDEACBCPar extends ASN1Encodable {
   ASN1OctetString iv;

   public static IDEACBCPar getInstance(Object o) {
      if (o instanceof IDEACBCPar) {
         return (IDEACBCPar)o;
      } else if (o instanceof ASN1Sequence) {
         return new IDEACBCPar((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("unknown object in IDEACBCPar factory");
      }
   }

   public IDEACBCPar(byte[] iv) {
      IDEACBCPar var10000 = this;
      super();
      DEROctetString var2;
      var2 = new DEROctetString.<init>(iv);
      var10000.iv = var2;
   }

   public IDEACBCPar(ASN1Sequence seq) {
      if (seq.size() == 1) {
         this.iv = (ASN1OctetString)seq.getObjectAt(0);
      } else {
         this.iv = null;
      }

   }

   public byte[] getIV() {
      ASN1OctetString var1;
      return (var1 = this.iv) != null ? var1.getOctets() : null;
   }

   public DERObject toASN1Object() {
      IDEACBCPar var10000 = this;
      ASN1EncodableVector var2;
      var2 = new ASN1EncodableVector.<init>();
      ASN1OctetString var1;
      if ((var1 = var10000.iv) != null) {
         var2.add(var1);
      }

      return new DERSequence(var2);
   }
}
